 /*
 * File:   lpcudk_16f145x.h
 * Author: vsk
 *
 * Created on 17. April 2015
 */
#ifndef _LPCUDK_16F145x_H
#define _LPCUDK_16F145x_H

// ------------------------------------------------------ fixed_address_momory.h
#define FIXED_ADDRESS_MEMORY

#define HID_CUSTOM_OUT_DATA_BUFFER_ADDRESS  0x2050
#define HID_CUSTOM_IN_DATA_BUFFER_ADDRESS   0x20A0

//#define IN_DATA_BUFFER_ADDRESS_TAG      @0x240
//#define OUT_DATA_BUFFER_ADDRESS_TAG     @0x280
//#define CONTROL_BUFFER_ADDRESS_TAG      @0x2C0
//
//#define IN_DATA_BUFFER_ADDRESS_TAG      @0x0A0
//#define OUT_DATA_BUFFER_ADDRESS_TAG     @0x120
//#define CONTROL_BUFFER_ADDRESS_TAG      @0x1A0

// --------------------------------------------------------------------- power.h
//                                                      legacy HardwareProfile.h
typedef enum
{
    POWER_SOURCE_USB,
    POWER_SOURCE_MAINS
} POWER_SOURCE;

/*********************************************************************
* Function: POWER_SOURCE POWER_SourceGet(void)
*
* Overview: Gets the current source of power for the board
* PreCondition: None
* Input: None
* Output: POWER_SOURCE - the current source of power for the board
*
********************************************************************/
//POWER_SOURCE POWER_SourceGet(void);
//#define POWER_SourceGet() POWER_SOURCE_MAINS
#define POWER_SourceGet() POWER_SOURCE_USB

//---------------------------------------------------------------------------OSC
#define USE_INTERNAL_OSC

// ------------------------------------------current adc/buttons/leds. h/c files
//                                                      legacy HardwareProfile.h


//-------------------------------------------------------------------------- LED
//#define mInitAllLEDs()      LATC &= 0xF0; TRISC &= 0xF0
#define mInitAllLEDs()      LATC &= 0xF3; TRISC &= 0xF3

//#define mLED_1              LATCbits.LATC0  // pin used for ICSP
//#define mLED_2              LATCbits.LATC1  //   ""
#define mLED_3              LATCbits.LATC2
#define mLED_4              LATCbits.LATC3

//#define mGetLED_1()         mLED_1
//#define mGetLED_2()         mLED_2
#define mGetLED_3()         mLED_3
#define mGetLED_4()         mLED_4

//#define mLED_1_On()         mLED_1 = 1
//#define mLED_2_On()         mLED_2 = 1
#define mLED_3_On()         mLED_3 = 1
#define mLED_4_On()         mLED_4 = 1

//#define mLED_1_Off()        mLED_1 = 0
//#define mLED_2_Off()        mLED_2 = 0
#define mLED_3_Off()        mLED_3 = 0
#define mLED_4_Off()        mLED_4 = 0

//#define mLED_1_Toggle()     mLED_1 = !mLED_1
//#define mLED_2_Toggle()     mLED_2 = !mLED_2
#define mLED_3_Toggle()     mLED_3 = !mLED_3
#define mLED_4_Toggle()     mLED_4 = !mLED_4

//----------------------------------------------------------------------- SWITCH
#define mInitSwitch()       
//TRISAbits.TRISA3 = 1 // ???
#define mGetSwitch()        !PORTAbits.RA3

//------------------------------------------------------------------------- POTI
#if defined __16F1459
  #define mInitPoti()       ANSELBbits.ANSB4 = 1; TRISBbits.TRISB4 = 1
#elif defined __16F1455
  #define mInitPoti()       ANSELAbits.ANSA4 = 1; TRISA |= 0x10
//bits.TRISAA4 = 1
#endif

// ANSELBbits.ANSB4 = 1; TRISBbits.TRISB4 = 1
#define mGetPoti()
// PORTBbits.RB4

#define ConvertADC()        ADCON0bits.GO = 1
#define BusyADC()           ADCON0bits.GO == 1
//NOT_DONE

void initADC(void);
void initSpecialEventTrigger(void);

//Make sure to turn on active clock tuning for USB full speed operation INTOSC
//  HFINTOSC @ 16MHz, 3X PLL, PLL enabled; Active clock tuning enabled for USB
#define initCLKPLL()        OSCCON = 0xFC; ACTCON = 0x90

#endif //_LPCUDK_16F145x_H
